<?php
/**
 * @version     2.0.0
 * @package     com_jsonglyrics
 * @copyright   Copyright (C) 2014. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 * @author      John Kouvakis <john@kouvakis.gr> - http://www.kouvakis.gr
 */
// no direct access
defined('_JEXEC') or die;

JHtml::addIncludePath(JPATH_COMPONENT . '/helpers/html');
JHtml::_('behavior.tooltip');
JHtml::_('behavior.formvalidation');
JHtml::_('formbehavior.chosen', 'select');
JHtml::_('behavior.keepalive');

// Import CSS
$document = JFactory::getDocument();
$document->addStyleSheet('components/com_jsonglyrics/assets/css/jsonglyrics.css');
?>
<script type="text/javascript">
	js = jQuery.noConflict();
	var song_editor;

	js.fn.myTextEditor = function(options){
		// extend the option with the default ones
		var settings = js.extend({width: "100%", height : "400px"}, options);
        return this.each(function() {
			var jsthis = js(this).hide();
			// create a container div on the fly
			var containerDiv = js("<div/>",{
				css : {
					width : settings.width,
					height : settings.height
				}
			});
			jsthis.after(containerDiv); 
			song_editor = js("<iframe/>",{
				frameborder : "0",
				id : 'song_editor',
				css : {
					width: settings.width,
					height: settings.height,
					border: '1px solid #ddd',
					'border-radius': '10px',
					'margin-top': '20px'
				}
			}).appendTo(containerDiv).get(0);

			var song_editor_content = '';
			var textareatags = js(js("#jform_song").val()).get();
			js(textareatags).each(function(index, value) {
				if ((js.trim(value.innerHTML) != "") || (value.className == "jsl_empty")) {
					var preelem = js("<pre/>", {
						class : value.className,
						html : value.innerHTML
					});
					song_editor_content += preelem.get(0).outerHTML +"\n";
				}
			});

			// opening and closing the editor is a workaround to solve issue in Firefox
			song_editor.contentWindow.document.open();
			song_editor.contentWindow.document.close();
			song_editor.contentWindow.document.write("<head><style type=\"text/css\">");
			song_editor.contentWindow.document.write('.jsl_chords { font-family: Courier New; font-size: 14px; color: #FF0000; margin:0; padding:0; }');
			song_editor.contentWindow.document.write('.jsl_lyrics { font-family: Courier New; font-size: 14px; color: #000000; margin:0; padding:0; }');
			song_editor.contentWindow.document.write('.jsl_tabs { font-family: Courier New; font-size: 14px; color: #000000; margin:0; padding:0; }');
			song_editor.contentWindow.document.write('.jsl_comments {font-family: Courier New; font-size: 12px; color: #7F7F7F; font-style: italic; margin:0; padding:0; }');
			song_editor.contentWindow.document.write('.jsl_empty { padding-top: 14px; }');
			song_editor.contentWindow.document.write("</style></head><body>");
			song_editor.contentWindow.document.write(song_editor_content);
			song_editor.contentWindow.document.write("</body>");
			song_editor.contentWindow.document.designMode="on";

			js(song_editor.contentWindow).on("click", function() {
				var contentWindow = song_editor.contentWindow;
				//contentWindow.focus();
				var caretElement = getSelectionBoundaryElement(song_editor.contentWindow, true);
				var caretClass = js(caretElement).attr('class');
				var btnID = "";
				if (caretClass.indexOf("jsl_") >= 0) {
					btnID = caretClass.substring(4);
				}
				js('.editor-btns .editbtn').removeClass("active");
				js('.editor-btns .editbtn').removeClass("btn-success");
				js('#sngbtn'+btnID).addClass("active").addClass("btn-success");
			});

			var buttonPane = js("<div/>", {
				"class" : "editor-btns btn-group",
			}).prependTo(containerDiv);

			var btnChords = js("<a/>",{
				href : "#",
				text : "Chords",
				id   : "sngbtnchords",
				class: "btn btn-default editbtn",
				data : {
					commandName : "chords"
				},
				click : execCommand 
			}).appendTo(buttonPane );

			var btnLyrics = js("<a/>",{
				href : "#",
				text : "Lyrics",
				id   : "sngbtnlyrics",
				class: "btn btn-default editbtn",
				data : {
					commandName : "lyrics"
				},
				click : execCommand 
			}).appendTo(buttonPane );

			var btnComments = js("<a/>",{
				href : "#",
				text : "Comments",
				id   : "sngbtncomments",
				class: "btn btn-default editbtn",
				data : {
					commandName : "comments"
				},
				click : execCommand 
			}).appendTo(buttonPane );

			var btnComments = js("<a/>",{
				href : "#",
				text : "Tabs",
				id   : "sngbtntabs",
				class: "btn btn-default editbtn",
				data : {
					commandName : "tabs"
				},
				click : execCommand 
			}).appendTo(buttonPane );

			var btnEmpty = js("<a/>",{
				href : "#",
				text : "Empty",
				id   : "sngbtnempty",
				class: "btn btn-default editbtn",
				data : {
					commandName : "empty"
				},
				click : execCommand 
			}).appendTo(buttonPane );

			function execCommand (e) {
				js('.editor-btns .editbtn').removeClass("active");
				js('.editor-btns .editbtn').removeClass("btn-success");
				js(this).addClass("active").addClass("btn-success");
				var contentWindow = song_editor.contentWindow;
				contentWindow.focus();
				var caretElement = getSelectionBoundaryElement(song_editor.contentWindow, true);
				js(caretElement).removeClass();
				js(caretElement).addClass('jsl_' + js(this).data("commandName"));
				return false;
			}
		});
	};

	js(document).ready(function(){
		js("#jform_song").myTextEditor();
	});

	function getSelectionBoundaryElement(win, isStart) {
		var range, sel, container = null;
		var doc = win.document;

		if (doc.selection) {
			// IE branch
			range = doc.selection.createRange();
			range.collapse(isStart);
			return range.parentElement();
	    } else if (win.getSelection) {
			// Other browsers
			sel = win.getSelection();

			if (sel.rangeCount > 0) {
				range = sel.getRangeAt(0);
				container = range[isStart ? "startContainer" : "endContainer"];
				// Check if the container is a text node and return its parent if so
				if (container.nodeType === 3) {
					container = container.parentNode;
				}
			}
		}
		return container;
	}

	Joomla.submitbutton = function(task) {
		//js('textarea#jform_song').val(song_editor.contentWindow.document.body.innerHTML);

		var textareatags = js(song_editor.contentWindow.document.body.innerHTML).get();
		var song_editor_content = "";
		js(textareatags).each(function(index, value) {
			if ((js.trim(value.innerHTML) != "") || (value.className == "jsl_empty")) {
				var paragraphelem = js("<p/>", {
					class : value.className,
					html : value.innerHTML.replace(/&nbsp;/g, ' ')
				});
				song_editor_content += paragraphelem.get(0).outerHTML +"\n";
			}
		});
		js('textarea#jform_song').val(song_editor_content);

		if (task == 'song.cancel') {
			Joomla.submitform(task, document.getElementById('song-form'));
		} else {
			if (task != 'song.cancel' && document.formvalidator.isValid(document.id('song-form'))) {
				Joomla.submitform(task, document.getElementById('song-form'));
			} else {
				alert('<?php echo $this->escape(JText::_('JGLOBAL_VALIDATION_FORM_FAILED')); ?>');
			}
		}
	}
</script>

<form action="<?php echo JRoute::_('index.php?option=com_jsonglyrics&layout=edit&id=' . (int) $this->item->id); ?>" method="post" enctype="multipart/form-data" name="adminForm" id="song-form" class="form-validate">

	<div class="form-horizontal">
		<?php echo JHtml::_('bootstrap.startTabSet', 'myTab', array('active' => 'general')); ?>

		<?php echo JHtml::_('bootstrap.addTab', 'myTab', 'general', JText::_('COM_JSONGLYRICS_TITLE_SONG', true)); ?>
		<div class="row-fluid">
			<div class="span8">
				<div class="control-group">
					<?php echo $this->form->getInput('song'); ?>
				</div>
			</div>
			<div class="span4">
				<div class="control-group">
					<?php echo $this->form->getLabel('id'); ?>
					<?php echo $this->form->getInput('id'); ?>
				</div>
				<div class="control-group">
					<?php echo $this->form->getLabel('state'); ?>
					<?php echo $this->form->getInput('state'); ?>
				</div>
				<div class="control-group">
					<?php echo $this->form->getLabel('created_by'); ?>
					<?php echo $this->form->getInput('created_by'); ?>
				</div>
				<div class="control-group">
					<?php echo $this->form->getLabel('title'); ?>
					<?php echo $this->form->getInput('title'); ?>
				</div>
				<div class="control-group">
					<?php echo $this->form->getLabel('artist'); ?>
					<?php echo $this->form->getInput('artist'); ?>
				</div>
				<div class="control-group">
					<?php echo $this->form->getLabel('creator1'); ?>
					<?php echo $this->form->getInput('creator1'); ?>
				</div>
				<div class="control-group">
					<?php echo $this->form->getLabel('creator2'); ?>
					<?php echo $this->form->getInput('creator2'); ?>
				</div>
			</div>
		</div>
		<?php echo JHtml::_('bootstrap.endTab'); ?>



		<?php echo JHtml::_('bootstrap.endTabSet'); ?>

		<input type="hidden" name="task" value="" />
		<?php echo JHtml::_('form.token'); ?>

	</div>
</form>