<?php
/**
 * @version     2.0.0
 * @package     com_jsonglyrics
 * @copyright   Copyright (C) 2014. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 * @author      John Kouvakis <john@kouvakis.gr> - http://www.kouvakis.gr
 */

// No direct access
defined('_JEXEC') or die;

/**
 * @param	array	A named array
 * @return	array
 */
function JsonglyricsBuildRoute(&$query) {
	$segments = array();

	if (isset($query['view'])) {
		$segments[] = implode('/',explode('.',$query['view']));
		unset($query['view']);
	}

	if (isset($query['id'])) {
		$segments[] = $query['id'];
		unset($query['id']);
	}

	return $segments;
}

/**
 * @param	array	A named array
 * @param	array
 *
 * Formats:
 *
 * index.php?/jsonglyrics/task/id/Itemid
 *
 * index.php?/jsonglyrics/id/Itemid
 */
function JsonglyricsParseRoute($segments) {
	$vars = array();

	switch($segments[0]) {
		case 'songs':
			$vars['view'] = 'songs';
			break;
		case 'song':
			$vars['view'] = 'song';
			$id = explode( ':', $segments[1] );
			$vars['id'] = (int) $id[0];
			break;
	}
	return $vars;
}
